import { world, MinecraftBlockTypes } from "@minecraft/server"
world.events.projectileHit.subscribe(r => {
    if (r.blockHit.block.type.id == "minecraft:snow" && r.source.hasTag("snow")) {
        r.blockHit.block.setType(MinecraftBlockTypes.air)
    }
    if (!r.blockHit) return;
    if (!r.blockHit.block) return;
    if (!r.projectile) return;
    if (!r.entityHit) return;
})
world.events.projectileHit.subscribe(r => {
    if (!r.source) return;
    if (!r.projectile) return;
    if (!r.entityHit) return
    const hitter = r.source
    const victim = r.entityHit.entity

    if (hitter.hasTag("hit") && victim.hasTag("hit")) {
        hitter.runCommandAsync("clear @s arrow")
        hitter.runCommandAsync("give @s arrow 1 0")
        hitter.runCommandAsync("tag @s add default_title")
        victim.runCommandAsync("clear @s arrow")
        victim.runCommandAsync("give @s arrow 1 0")
        victim.runCommandAsync("tag @s add default_title")
        victim.runCommandAsync("tp @s @r[type=armor_stand,name=hit]")
        hitter.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You got §cone §6point§r!"}]}`)
        r.projectile.runCommandAsync("kill @s")
        victim.runCommandAsync("tag @s remove default_title")
        hitter.runCommandAsync("tag @s remove default_title")
        hitter.runCommandAsync("scoreboard players add @s hit 1")
    }

})
world.events.entityHit.subscribe(e => {
    if (e.hitBlock) return;
    const source = e.entity
    const victim = e.hitEntity
    if (source.hasTag("hit") && victim.hasTag("hit") && victim.hasTag("hit_one") && victim.hasTag("hit_two") && victim.hasTag("hit_three") && victim.hasTag("hit_four") && victim.hasTag("hit_five") == false) {
        victim.runCommandAsync("title @p actionbar you got five hits")
        victim.addTag("hit_five")
    }
    if (source.hasTag("hit") && victim.hasTag("hit") && victim.hasTag("hit_one") && victim.hasTag("hit_two") && victim.hasTag("hit_three") && victim.hasTag("hit_four") == false) {
        victim.runCommandAsync("title @p actionbar you got four hits")
        victim.addTag("hit_four")
    }
    if (source.hasTag("hit") && victim.hasTag("hit") && victim.hasTag("hit_one") && victim.hasTag("hit_two") && victim.hasTag("hit_three") == false) {
        victim.runCommandAsync("title @p actionbar you got three hits")
        victim.addTag("hit_three")
    }

    if (source.hasTag("hit") && victim.hasTag("hit") && victim.hasTag("hit_one") && victim.hasTag("hit_two") == false) {
        victim.runCommandAsync("title @p actionbar you got two hits")
        victim.addTag("hit_two")
    }

    if (source.hasTag("hit") && victim.hasTag("hit") && victim.hasTag("hit_one") == false) {
        victim.addTag("hit_one")
        victim.runCommandAsync("title @p actionbar you got one hits")
    }
    if (source.hasTag("hit") && victim.hasTag("hit") && victim.hasTag("hit_one") && victim.hasTag("hit_two") && victim.hasTag("hit_three") && victim.hasTag("hit_four") && victim.hasTag("hit_five")) {
        victim.removeTag("hit_one")
        victim.removeTag("hit_two")
        victim.removeTag("hit_three")
        victim.removeTag("hit_four")
        victim.removeTag("hit_five")
        source.runCommandAsync("clear @s arrow")
        source.runCommandAsync("give @s arrow 1 0")
        source.runCommandAsync("tag @s add default_title")
        victim.runCommandAsync("clear @s arrow")
        victim.runCommandAsync("give @s arrow 1 0")
        victim.runCommandAsync("tag @s add default_title")
        victim.runCommandAsync("tp @s @r[type=armor_stand,name=hit]")
        source.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You got §cone §6point§r!"}]}`)
        victim.runCommandAsync("tag @s remove default_title")
        source.runCommandAsync("tag @s remove default_title")
        source.runCommandAsync("scoreboard players add @s hit 1")
    }
})