import { world } from "@minecraft/server"
import { ActionFormData } from "@minecraft/server-ui";


//Function
const getScore = (objective, target, useZero = true) => {
    try {
        const obj = world.scoreboard.getObjective(objective);
        if (typeof target == 'string') {
            return obj.getScore(obj.getParticipants().find(v => v.displayName == target));
        }
        return obj.getScore(target.scoreboard);
    } catch {
        return useZero ? 0 : NaN;
    }
}

//Shop Keeper System
world.events.entityHit.subscribe(r => {
    if (!r.hitEntity) return;
    const hitter = r.entity
    const victim = r.hitEntity
    if (victim.typeId == "s:shop_keeper") {
        const action_o = new ActionFormData()
        action_o.title("§bThe Shop Keeper")
        action_o.body(`Choose what you want to buy\nYour §gCoins§c ${getScore("coins", hitter)}`)
        action_o.button("Bundles")
        action_o.button("Coming Soon!")
        action_o.show(hitter).then(r => {
            const select = r.selection
            const cancel = r.canceled
            //Bundle System
            if (select === 0) {
                const action = new ActionFormData()
                let Raven = "§cRaven Bundle\n300"
                let Mushroom = "§cMushroom\nBundle 500"
                let Knight = "§cKnight Bundle\n520"
                let King = "§cVillager King\nBundle800"
                let Goat = "§cG.O.A.T. Bundle 800"
                let Alien = "§cAlien Bundle 800"
                let Dragon = "§cDragon Bundle 800"

                if (hitter.hasTag("raven")) {
                    Raven = "§5Raven\nYou already got it!"
                }
                if (hitter.hasTag("pilz")) {
                    Mushroom = "§5Mushroom\nYou already got it!"
                }
                if (hitter.hasTag("knight")) {
                    Knight = "§5Knight\nYou already got it!"
                }
                if (hitter.hasTag("villager_king")) {
                    King = "§5Villager King\nYou already got it!"
                }
                if (hitter.hasTag("goat")) {
                    Goat = "§5G.O.A.T.\nYou already got it!"
                }
                if (hitter.hasTag("alien")) {
                    Alien = "§5Alien\nYou already got it!"
                }
                if (hitter.hasTag("dragon")) {
                    Dragon = "§5Dragon\nYou already got it"
                }
                action.title("§lShop Bundle")
                action.body(`Buy your §bBundle§f\nYour §gCoins§c ${getScore("coins", hitter)}`)
                action.button(Raven)
                action.button(Mushroom)
                action.button(Knight)
                action.button(King)
                action.button(Goat)
                action.button(Alien)
                action.button(Dragon)
                action.button("§cClose")
                action.show(hitter).then(r => {
                    //Bundle Buy System
                    //Raven Bundle
                    const select = r.selection
                    if (select === 0 && hitter.hasTag("raven") == false && getScore("coins", hitter) >= 300) {
                        hitter.runCommandAsync(`tellraw @s {"rawtext":[{"text":"Nice work! you got the §bRaven Bundle"}]}`)
                        hitter.runCommandAsync("playsound conduit.activate")
                        hitter.runCommandAsync("tag @s add raven")
                        hitter.runCommandAsync("scoreboard players remove @s coins 300")
                    }
                    if (select == 0 && hitter.hasTag("raven") == false && getScore("coins", hitter) < 300) {
                        hitter.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§cYou need§f ${300 - getScore("coins", hitter)} §cmore §gcoins!"}]}`)
                    }
                    if (select === 0 && hitter.hasTag("raven")) {
                        hitter.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You already got it!"}]}`)
                    }
                    //Mushroom Bundle
                    if (select === 1 && hitter.hasTag("pilz") == false && getScore("coins", hitter) >= 500) {
                        hitter.runCommandAsync(`tellraw @s {"rawtext":[{"text":"Nice work! you got the §bMushroom Bundle"}]}`)
                        hitter.runCommandAsync("playsound conduit.activate")
                        hitter.runCommandAsync("tag @s add pilz")
                        hitter.runCommandAsync("scoreboard players remove @s coins 300")
                    }
                    if (select == 1 && hitter.hasTag("pilz") == false && getScore("coins", hitter) < 500) {
                        hitter.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§cYou need§f ${500 - getScore("coins", hitter)} §cmore §gcoins!"}]}`)
                    }
                    if (select === 1 && hitter.hasTag("pilz")) {
                        hitter.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You already got it!"}]}`)
                    }
                    //Kight Bundle
                    if (select === 2 && hitter.hasTag("knight") == false && getScore("coins", hitter) >= 520) {
                        hitter.runCommandAsync(`tellraw @s {"rawtext":[{"text":"Nice work! you got the §bKnight Bundle"}]}`)
                        hitter.runCommandAsync("playsound conduit.activate")
                        hitter.runCommandAsync("tag @s add knight")
                        hitter.runCommandAsync("scoreboard players remove @s coins 520")
                    }
                    if (select == 2 && hitter.hasTag("knight") == false && getScore("coins", hitter) < 520) {
                        hitter.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§cYou need§f ${520 - getScore("coins", hitter)} §cmore §gcoins!"}]}`)
                    }
                    if (select === 2 && hitter.hasTag("knight")) {
                        hitter.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You already got it!"}]}`)
                    }
                    //Villager King Bundle
                    if (select === 3 && hitter.hasTag("villager_king") == false && getScore("coins", hitter) >= 800) {
                        hitter.runCommandAsync(`tellraw @s {"rawtext":[{"text":"Nice work! you got the §bVillager King Bundle"}]}`)
                        hitter.runCommandAsync("playsound conduit.activate")
                        hitter.runCommandAsync("tag @s add villager_king")
                        hitter.runCommandAsync("scoreboard players remove @s coins 800")
                    }
                    if (select == 3 && hitter.hasTag("villager_king") == false && getScore("coins", hitter) < 800) {
                        hitter.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§cYou need§f ${800 - getScore("coins", hitter)} §cmore §gcoins!"}]}`)
                    }
                    if (select === 3 && hitter.hasTag("villager_king")) {
                        hitter.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You already got it!"}]}`)
                    }
                    //G.O.A.T. Bundle
                    if (select === 4 && hitter.hasTag("goat") == false && getScore("coins", hitter) >= 800) {
                        hitter.runCommandAsync(`tellraw @s {"rawtext":[{"text":"Nice work! you got the §bG.O.A.T. Bundle"}]}`)
                        hitter.runCommandAsync("playsound conduit.activate")
                        hitter.runCommandAsync("tag @s add goat")
                        hitter.runCommandAsync("scoreboard players remove @s coins 800")
                    }
                    if (select == 4 && hitter.hasTag("goat") == false && getScore("coins", hitter) < 800) {
                        hitter.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§cYou need§f ${800 - getScore("coins", hitter)} §cmore §gcoins!"}]}`)
                    }
                    if (select === 4 && hitter.hasTag("goat")) {
                        hitter.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You already got it!"}]}`)
                    }
                    //Alien Bundle
                    if (select === 5 && hitter.hasTag("alien") == false && getScore("coins", hitter) >= 800) {
                        hitter.runCommandAsync(`tellraw @s {"rawtext":[{"text":"Nice work! you got the §bAlien Bundle"}]}`)
                        hitter.runCommandAsync("playsound conduit.activate")
                        hitter.runCommandAsync("tag @s add alien")
                        hitter.runCommandAsync("scoreboard players remove @s coins 800")
                    }
                    if (select == 5 && hitter.hasTag("alien") == false && getScore("coins", hitter) < 800) {
                        hitter.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§cYou need§f ${800 - getScore("coins", hitter)} §cmore §gcoins!"}]}`)
                    }
                    if (select === 5 && hitter.hasTag("alien")) {
                        hitter.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You already got it!"}]}`)
                    }
                    //Dragon Bundle
                    if (select === 6 && hitter.hasTag("dragon") == false && getScore("coins", hitter) >= 800) {
                        hitter.runCommandAsync(`tellraw @s {"rawtext":[{"text":"Nice work! you got the §bDragon Bundle"}]}`)
                        hitter.runCommandAsync("playsound conduit.activate")
                        hitter.runCommandAsync("tag @s add dragon")
                        hitter.runCommandAsync("scoreboard players remove @s coins 800")
                    }
                    if (select == 6 && hitter.hasTag("dragon") == false && getScore("coins", hitter) < 800) {
                        hitter.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§cYou need§f ${800 - getScore("coins", hitter)} §cmore §gcoins!"}]}`)
                    }
                    if (select === 6 && hitter.hasTag("dragon")) {
                        hitter.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You already got it!"}]}`)
                    }

                })

            }
        })
    }
})