import { world, system } from "@minecraft/server"
import { ActionFormData, ModalFormData } from "@minecraft/server-ui"
world.events.itemUse.subscribe(d => {
    const player = d.source
    const item = d.item
    if (item.typeId == "s:settings") {
        const action_first = new ActionFormData()
        action_first.title("Settings")
        action_first.body("Choose one of the settings to change the game!")
        action_first.button("Music")
        if (player.hasTag("bg")) {
            action_first.button("Rounds")
            action_first.button("Mode")
        }
        action_first.show(player).then(r => {
            if (r.selection === 0) {
                const modal = new ModalFormData()
                modal.title("Settings")
                modal.toggle("Off = No Music| On = Music", false)
                modal.show(player).then(r => {
                    if (r.formValues[0] == true) {
                        player.runCommandAsync("playsound note.pling @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You set Music to §aon§f"}]}`)
                        player.addTag("music")
                    }
                    if (r.formValues[0] == false) {
                        player.runCommandAsync("playsound beacon.deactivate @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You set Music to §coff§f"}]}`)
                        player.removeTag("music")
                    }
                })
            }
            if (r.selection === 1) {
                const modal = new ModalFormData()
                modal.title("Rounds Setting")
                modal.slider("Rounds", 5, 20, 5, 10)
                modal.show(player).then(r => {
                    if (r.formValues[0] == 5) {
                        player.runCommandAsync("tag @s remove r10")
                        player.runCommandAsync("tag @s remove r15")
                        player.runCommandAsync("tag @s remove r20")
                        player.runCommandAsync("tag @s add r5")
                    }
                    if (r.formValues[0] == 10) {
                        player.runCommandAsync("tag @s remove r5")
                        player.runCommandAsync("tag @s remove r15")
                        player.runCommandAsync("tag @s remove r20")
                        player.runCommandAsync("tag @s add r10")
                    }
                    if (r.formValues[0] == 15) {
                        player.runCommandAsync("tag @s remove r5")
                        player.runCommandAsync("tag @s remove r10")
                        player.runCommandAsync("tag @s remove r20")
                        player.runCommandAsync("tag @s add r15")
                    }
                    if (r.formValues[0] == 20) {
                        player.runCommandAsync("tag @s remove r5")
                        player.runCommandAsync("tag @s remove r10")
                        player.runCommandAsync("tag @s remove r15")
                        player.runCommandAsync("tag @s add r20")
                    }
                })
            }
            if (r.selection === 2) {
                const modal = new ModalFormData()
                modal.title("Mode Setting")
                modal.dropdown("Mode Selector", ["Random", "Choosing"], 0)
                modal.show(player).then(r => {
                    if (r.formValues[0] === 0) {
                        player.runCommandAsync("tag @s remove shost")
                        player.runCommandAsync("tag @s add rhost")
                    }
                    if (r.formValues[0] === 1) {
                        player.runCommandAsync("tag @s remove rhost")
                        player.runCommandAsync("tag @s add shost")
                    }
                })
            }
        }
        )

    }
})




