import { world, system } from "@minecraft/server"
import { ActionFormData, ModalFormData } from "@minecraft/server-ui"
world.events.itemUse.subscribe(d => {
    const player = d.source
    const item = d.item
    if (item.typeId == "s:c_start") {
        player.runCommandAsync("function start")
    }
    if (item.typeId == "s:start_button") {
        player.runCommandAsync("setblock -2 38 -5 redstone_block")
    }
    if (item.typeId == "s:stop_button") {
        player.runCommandAsync("function stop")
    }
    if (item.typeId == "s:spind") {
        const action = new ActionFormData()
        action.title("Locker")
        action.body("Your Cosmetics!")
        action.button("Costume")
        action.button("Hub Title")
        action.button("Voice Lines")
        action.button("Feedback")
        action.button("Codes")
        action.show(player).then(data => {
            const selection = data.selection

            //Costume System
            if (selection === 0) {
                const action = new ActionFormData()
                let Raven = "§cRaven"
                let Mushroom = "§cMushroom"
                let Knight = "§cKnight"
                let King = "§cVillager King"
                let Goat = "§cG.O.A.T."
                let Alien = "§cAlien"
                let Dragon = "§cDragon"
                let Olympian = "§5Olympian(No Skin)"

                if (player.hasTag("raven")) {
                    Raven = "§5Raven"
                }
                if (player.hasTag("pilz")) {
                    Mushroom = "§5Mushroom"
                }
                if (player.hasTag("knight")) {
                    Knight = "§5Knight"
                }
                if (player.hasTag("villager_king")) {
                    King = "§5Villager King"
                }
                if (player.hasTag("goat")) {
                    Goat = "§5G.O.A.T."
                }
                if (player.hasTag("alien")) {
                    Alien = "§5Alien"
                }
                if (player.hasTag("dragon")) {
                    Dragon = "§5Dragon"
                }
                action.title("Costume")
                action.body("Choose your Costume")
                action.button(Raven)
                action.button(Mushroom)
                action.button(Knight)
                action.button(King)
                action.button(Goat)
                action.button(Alien)
                action.button(Dragon)
                action.button(Olympian)
                action.button("§4Default§r")
                action.show(player).then(data => {
                    if (player.hasTag("raven") && data.selection === 0) {
                        player.runCommandAsync("event entity @s raven")
                        player.runCommandAsync("playsound zipper @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the 'Raven' Costume"}]}`)
                    }
                    if (player.hasTag("pilz") && data.selection === 1) {
                        player.runCommandAsync("event entity @s pilza")
                        player.runCommandAsync("playsound zipper @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the 'Mushroom' Costume"}]}`)
                    }
                    if (player.hasTag("knight") && data.selection === 2) {
                        player.runCommandAsync("event entity @s knight")
                        player.runCommandAsync("playsound zipper @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the 'Knight' Costume"}]}`)
                    }
                    if (player.hasTag("villager_king") && data.selection === 3) {
                        player.runCommandAsync("event entity @s king")
                        player.runCommandAsync("playsound zipper @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the 'Villager King' Costume"}]}`)
                    }
                    if (player.hasTag("goat") && data.selection === 4) {
                        player.runCommandAsync("event entity @s goat")
                        player.runCommandAsync("playsound zipper @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the 'G.O.A.T.' Costume"}]}`)
                    }
                    if (player.hasTag("alien") && data.selection === 5) {
                        player.runCommandAsync("event entity @s alien")
                        player.runCommandAsync("playsound zipper @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the 'Alien' Costume"}]}`)
                    }
                    if (player.hasTag("dragon") && data.selection === 6) {
                        player.runCommandAsync("event entity @s dragon")
                        player.runCommandAsync("playsound zipper @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the 'Dragon' Costume"}]}`)
                    }
                    if (data.selection === 7) {
                        player.runCommandAsync("event entity @s o_olympian")
                        player.runCommandAsync("playsound zipper @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the '§6Olympian§r' Costume"}]}`)
                    }
                    if (data.selection === 8) {
                        player.runCommandAsync("event entity @s default")
                        player.runCommandAsync("playsound zipper @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"Set your Costume to §cDefault"}]}`)
                    }
                })
            }
            if (selection === 1) {
                //Hubtitle
                const action = new ActionFormData()
                let Raven = "§cOpen Your Wings"
                let Mushroom = "§cI am a\nMushroom"
                let Knight = "§cNever break\nyour Codex"
                let King = "§cKneel down"
                let Goat = "§cThe G.O.A.T."
                let Alien = "§cEverything Calculated"
                let Dragon = "§cIt's getting hot!"

                if (player.hasTag("raven")) {
                    Raven = "§5Open Your Wings"
                }
                if (player.hasTag("pilz")) {
                    Mushroom = "§5I am a\nMushroom"
                }
                if (player.hasTag("knight")) {
                    Knight = "§5Never break\nyour Codex"
                }
                if (player.hasTag("villager_king")) {
                    King = "§5Kneel down"
                }
                if (player.hasTag("goat")) {
                    Goat = "§5The G.O.A.T."
                }
                if (player.hasTag("alien")) {
                    Alien = "§5Everything Calculated"
                }
                if (player.hasTag("dragon")) {
                    Dragon = "§5It's getting hot!"
                }
                action.title("Hub Title")
                action.body("Choose your Hub Title")
                action.button(Raven)
                action.button(Mushroom)
                action.button(Knight)
                action.button(King)
                action.button(Goat)
                action.button(Alien)
                action.button(Dragon)
                action.button("§4Default§r")
                action.show(player).then(data => {
                    if (player.hasTag("raven") && data.selection === 0) {
                        player.runCommandAsync("tag @s remove pilz_title")
                        player.runCommandAsync("tag @s remove knight_title")
                        player.runCommandAsync("tag @s remove villager_king_title")
                        player.runCommandAsync("tag @s remove goat_title")
                        player.runCommandAsync("tag @s add raven_title")
                        player.runCommandAsync("tag @s remove default_title")
                        player.runCommandAsync("tag @s remove alien_title")
                        player.runCommandAsync("tag @s remove dragon_title")
                        player.runCommandAsync("playsound note.pling @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the Hubtitle: Open Your Wings"}]}`)
                    }
                    if (player.hasTag("pilz") && data.selection === 1) {
                        player.runCommandAsync("tag @s add pilz_title")
                        player.runCommandAsync("tag @s remove knight_title")
                        player.runCommandAsync("tag @s remove villager_king_title")
                        player.runCommandAsync("tag @s remove goat_title")
                        player.runCommandAsync("tag @s remove default_title")
                        player.runCommandAsync("tag @s remove raven_title")
                        player.runCommandAsync("playsound note.pling @s")
                        player.runCommandAsync("tag @s remove alien_title")
                        player.runCommandAsync("tag @s remove dragon_title")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the Hubtitle: I am a Mushroom"}]}`)
                    }
                    if (player.hasTag("knight") && data.selection === 2) {
                        player.runCommandAsync("tag @s remove pilz_title")
                        player.runCommandAsync("tag @s add knight_title")
                        player.runCommandAsync("tag @s remove villager_king_title")
                        player.runCommandAsync("tag @s remove goat_title")
                        player.runCommandAsync("tag @s remove raven_title")
                        player.runCommandAsync("playsound note.pling @s")
                        player.runCommandAsync("tag @s remove alien_title")
                        player.runCommandAsync("tag @s remove dragon_title")
                        player.runCommandAsync("tag @s remove default_title")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the Hubtitle: Never break your Codex"}]}`)

                    }
                    if (player.hasTag("villager_king") && data.selection === 3) {
                        player.runCommandAsync("tag @s remove pilz_title")
                        player.runCommandAsync("tag @s remove knight_title")
                        player.runCommandAsync("tag @s add villager_king_title")
                        player.runCommandAsync("tag @s remove goat_title")
                        player.runCommandAsync("tag @s remove raven_title")
                        player.runCommandAsync("tag @s remove default_title")
                        player.runCommandAsync("tag @s remove alien_title")
                        player.runCommandAsync("tag @s remove dragon_title")
                        player.runCommandAsync("playsound note.pling @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the Hubtitle: Kneel down"}]}`)
                    }
                    if (player.hasTag("goat") && data.selection === 4) {
                        player.runCommandAsync("tag @s remove pilz_title")
                        player.runCommandAsync("tag @s remove knight_title")
                        player.runCommandAsync("tag @s remove villager_king_title")
                        player.runCommandAsync("tag @s add goat_title")
                        player.runCommandAsync("tag @s remove raven_title")
                        player.runCommandAsync("tag @s remove default_title")
                        player.runCommandAsync("tag @s remove alien_title")
                        player.runCommandAsync("tag @s remove dragon_title")
                        player.runCommandAsync("playsound note.pling @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the Hubtitle: The G.O.A.T."}]}`)
                    }
                    if (player.hasTag("alien") && data.selection === 5) {
                        player.runCommandAsync("tag @s remove pilz_title")
                        player.runCommandAsync("tag @s remove knight_title")
                        player.runCommandAsync("tag @s remove villager_king_title")
                        player.runCommandAsync("tag @s remove goat_title")
                        player.runCommandAsync("tag @s remove raven_title")
                        player.runCommandAsync("tag @s remove default_title")
                        player.runCommandAsync("tag @s add alien_title")
                        player.runCommandAsync("tag @s remove dragon_title")
                        player.runCommandAsync("playsound note.pling @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the Hubtitle: Everything Calculated"}]}`)
                    }
                    if (player.hasTag("dragon") && data.selection === 6) {
                        player.runCommandAsync("tag @s remove pilz_title")
                        player.runCommandAsync("tag @s remove knight_title")
                        player.runCommandAsync("tag @s remove villager_king_title")
                        player.runCommandAsync("tag @s remove goat_title")
                        player.runCommandAsync("tag @s remove raven_title")
                        player.runCommandAsync("tag @s remove default_title")
                        player.runCommandAsync("tag @s remove alien_title")
                        player.runCommandAsync("tag @s add dragon_title")
                        player.runCommandAsync("playsound note.pling @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the Hubtitle: It's getting §chot§r!"}]}`)
                    }
                    if (data.selection === 7) {
                        player.runCommandAsync("tag @s remove pilz_title")
                        player.runCommandAsync("tag @s remove knight_title")
                        player.runCommandAsync("tag @s remove villager_king_title")
                        player.runCommandAsync("tag @s remove goat_title")
                        player.runCommandAsync("tag @s remove raven_title")
                        player.runCommandAsync("tag @s add default_title")
                        player.runCommandAsync("playsound note.pling @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the default Hubtitle"}]}`)
                    }
                })

            }
            if (selection === 3) {
                //Feedback System
                const modal = new ModalFormData()
                modal.title("Give us your Feedback on this map")
                modal.textField("Input your Feedback here:", "f.e.: I really enjoy this map!")
                modal.slider("Stars", 0, 5, 1, 5)
                modal.show(player).then(response => {
                    player.runCommandAsync(`tellraw @a[tag=rhost] {"rawtext":[{"text":"${player.nameTag} said: ${response.formValues[0]}\nand gave §c${response.formValues[1]} §f of 5 §gStars§f!"}]}`)
                    player.runCommandAsync(`tellraw @a[tag=shost] {"rawtext":[{"text":"${player.nameTag} said: ${response.formValues[0]}\nand gave §c${response.formValues[1]} §f of 5 §gStars§f!"}]}`)
                })
            }
            if (selection === 4) {
                const modal = new ModalFormData()
                modal.title("Codes")
                modal.textField("Enter your codes here", "coin123")
                modal.show(player).then(r => {
                    if (r.formValues[0] == "coin300" && player.hasTag("coin300") == false) {
                        player.runCommandAsync("tag @s add coin300")
                        player.runCommandAsync("scoreboard players add @s coins 300")
                        player.runCommandAsync("playsound note.pling @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You got 300 coins!"}]}`)
                    }
                    if (r.formValues[0] == "coin5000" && player.hasTag("coin5000") == false) {
                        player.runCommandAsync("tag @s add coin5000")
                        player.runCommandAsync("scoreboard players add @s coins 800")
                        player.runCommandAsync("playsound note.pling @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You got 800 coins!"}]}`)
                    }
                    if (r.formValues[0] == "coin500" && player.hasTag("coin500") == false) {
                        player.runCommandAsync("tag @s add coin500")
                        player.runCommandAsync("scoreboard players add @s coins 500")
                        player.runCommandAsync("playsound note.pling @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You got 500 coins!"}]}`)
                    }
                    if (r.formValues[0] == "ao") {
                        player.runCommandAsync("event entity @s olympian")
                        player.runCommandAsync("playsound note.pling @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the elite Costume!"}]}`)
                    }
                    if (r.formValues[0] == "mcpedl" && player.hasTag("mcpedl") == false) {
                        player.runCommandAsync("tag @s add mcpedl")
                        player.runCommandAsync("scoreboard players add @s coins 800")
                        player.runCommandAsync("playsound note.pling @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You got 800 coins!"}]}`)
                    }
                })
            }
            if (selection === 2) {
                //Voice
                const action = new ActionFormData()
                let Raven = "§cRaven Voice"
                let Mushroom = "§cMushroom Voice"
                let Knight = "§cKnight Voice"
                let King = "§cVillager King\nVoice"
                let Goat = "§cGoat Voice"
                let Alien = "§cAlien Voice"
                let Dragon = "§cDragon Voice"

                if (player.hasTag("raven")) {
                    Raven = "§5Raven Voice"
                }
                if (player.hasTag("pilz")) {
                    Mushroom = "§5Mushroom Voice"
                }
                if (player.hasTag("knight")) {
                    Knight = "§5Knight Voice"
                }
                if (player.hasTag("villager_king")) {
                    King = "§5Villager King\nVoice"
                }
                if (player.hasTag("goat")) {
                    Goat = "§5Goat Voice"
                }
                if (player.hasTag("alien")) {
                    Alien = "§5Alien Voice"
                }
                if (player.hasTag("dragon")) {
                    Dragon = "§5Dragon Voice"
                }
                action.title("Voice Line")
                action.body("Choose your Voice Line")
                action.button(Raven)
                action.button(Mushroom)
                action.button(Knight)
                action.button(King)
                action.button(Goat)
                action.button(Alien)
                action.button(Dragon)
                action.button("§4Default§r")
                action.show(player).then(data => {
                    if (player.hasTag("raven") && data.selection === 0) {
                        player.runCommandAsync("tag @s remove pilz_voice")
                        player.runCommandAsync("tag @s remove knight_voice")
                        player.runCommandAsync("tag @s remove villager_king_voice")
                        player.runCommandAsync("tag @s remove goat_voice")
                        player.runCommandAsync("tag @s add raven_voice")
                        player.runCommandAsync("tag @s remove alien_voice")
                        player.runCommandAsync("tag @s remove dragon_voice")
                        player.runCommandAsync("playsound note.pling @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the Raven Voice Line"}]}`)
                    }
                    if (player.hasTag("pilz") && data.selection === 1) {
                        player.runCommandAsync("tag @s add pilz_voice")
                        player.runCommandAsync("tag @s remove knight_voice")
                        player.runCommandAsync("tag @s remove villager_king_voice")
                        player.runCommandAsync("tag @s remove goat_voice")
                        player.runCommandAsync("tag @s remove raven_voice")
                        player.runCommandAsync("tag @s remove alien_voice")
                        player.runCommandAsync("tag @s remove dragon_voice")
                        player.runCommandAsync("playsound note.pling @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the Mushroom Voice Line"}]}`)
                    }
                    if (player.hasTag("knight") && data.selection === 2) {
                        player.runCommandAsync("tag @s remove pilz_voice")
                        player.runCommandAsync("tag @s add knight_voice")
                        player.runCommandAsync("tag @s remove villager_king_voice")
                        player.runCommandAsync("tag @s remove goat_voice")
                        player.runCommandAsync("tag @s remove raven_voice")
                        player.runCommandAsync("tag @s remove alien_voice")
                        player.runCommandAsync("tag @s remove dragon_voice")
                        player.runCommandAsync("playsound note.pling @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the Knight Voice Line"}]}`)

                    }
                    if (player.hasTag("villager_king") && data.selection === 3) {
                        player.runCommandAsync("tag @s remove pilz_voice")
                        player.runCommandAsync("tag @s remove knight_voice")
                        player.runCommandAsync("tag @s add villager_king_voice")
                        player.runCommandAsync("tag @s remove goat_voice")
                        player.runCommandAsync("tag @s remove raven_voice")
                        player.runCommandAsync("tag @s remove alien_voice")
                        player.runCommandAsync("tag @s remove dragon_voice")
                        player.runCommandAsync("playsound note.pling @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the Villager King Voice Line"}]}`)
                    }
                    if (player.hasTag("goat") && data.selection === 4) {
                        player.runCommandAsync("tag @s remove pilz_voice")
                        player.runCommandAsync("tag @s remove knight_voice")
                        player.runCommandAsync("tag @s remove villager_king_voice")
                        player.runCommandAsync("tag @s add goat_voice")
                        player.runCommandAsync("tag @s remove raven_voice")
                        player.runCommandAsync("tag @s remove alien_voice")
                        player.runCommandAsync("tag @s remove dragon_voice")
                        player.runCommandAsync("playsound note.pling @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the G.O.A.T. Voice Line"}]}`)
                    }
                    if (player.hasTag("alien") && data.selection === 5) {
                        player.runCommandAsync("tag @s remove pilz_voice")
                        player.runCommandAsync("tag @s remove knight_voice")
                        player.runCommandAsync("tag @s remove villager_king_voice")
                        player.runCommandAsync("tag @s remove goat_voice")
                        player.runCommandAsync("tag @s remove raven_voice")
                        player.runCommandAsync("tag @s add alien_voice")
                        player.runCommandAsync("tag @s remove dragon_voice")
                        player.runCommandAsync("playsound note.pling @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the Alien Voice Line"}]}`)
                    }
                    if (player.hasTag("alien") && data.selection === 6) {
                        player.runCommandAsync("tag @s remove pilz_voice")
                        player.runCommandAsync("tag @s remove knight_voice")
                        player.runCommandAsync("tag @s remove villager_king_voice")
                        player.runCommandAsync("tag @s remove goat_voice")
                        player.runCommandAsync("tag @s remove raven_voice")
                        player.runCommandAsync("tag @s remove alien_voice")
                        player.runCommandAsync("tag @s add dragon_voice")
                        player.runCommandAsync("playsound note.pling @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the Dragon Voice Line"}]}`)
                    }
                    if (data.selection === 7) {
                        player.runCommandAsync("tag @s remove pilz_voice")
                        player.runCommandAsync("tag @s remove knight_voice")
                        player.runCommandAsync("tag @s remove villager_king_voice")
                        player.runCommandAsync("tag @s remove goat_voice")
                        player.runCommandAsync("tag @s remove raven_voice")
                        player.runCommandAsync("tag @s remove alien_voice")
                        player.runCommandAsync("tag @s remove dragon_voice")
                        player.runCommandAsync("playsound note.pling @s")
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You equipped the default Voice Line"}]}`)
                    }
                })

            }
        })
    }
})




